#ifndef _RSDECODER_H
#define _RSDECODER_H 1

#include <fecpp.h>
#include <stdint.h>

#include <map>

#include "reorderer.h"

class Sender;

class RSDecoder : public Sender {
public:
	RSDecoder(Sender *sender);
	virtual void send_packet(uint16_t proto, const std::string &data, uint32_t incoming_seq);

	int get_recovered_packets() const { return num_recovered_packets; }

private:
	struct RSGroup {
		std::map<int, GREPacket> packets;
		bool done;
	};
	Sender *sender;
	std::map<int, RSGroup> rs_groups;
	fecpp::fec_code rs;

	int num_recovered_packets = 0;
};

#endif  /* !defined(_RSDECODER_H) */
