#ifndef _TUNPROTOCOL_H
#define _TUNPROTOCOL_H 1

#include "protocol.h"

#include <stdint.h>
#include <string>

class TUNProtocol : public Sender, public Reader {
public:
	TUNProtocol(const char *devname);
	virtual void send_packet(uint16_t proto, const std::string &data, uint32_t incoming_seq);
	virtual int fd() const;
	virtual void read_packet(Sender* sender);

	int get_received_packets() const { return received_packets; }
	int get_sent_packets() const { return sent_packets; }

private:
	int tunfd;
	uint32_t seq;

	int received_packets = 0, sent_packets = 0;
};

#endif  // !defined(_TUNPROTOCOL_H)
